Attribute VB_Name = "mComdlgDefs"
Option Explicit
'
' Brought to you by Brad Martinez
'   http://members.aol.com/btmtz/vb
'   http://www.mvps.org/ccrp
'

Public Const MAX_PATH = 260
Public Const WM_CLOSE = &H10

Public Type POINTAPI   ' pt
  x As Long
  y As Long
End Type

Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                            (ByVal hWnd As Long, _
                            ByVal wMsg As Long, _
                            ByVal wParam As Long, _
                            lParam As Any) As Long   ' <---

Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Declare Function WindowFromPoint Lib "user32" (ByVal x As Long, ByVal y As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal nMaxCount As Long) As Long

' ========================================================

Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Type OPENFILENAME  '  ofn
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As OFN_Flags
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

' All lp strings are Longs
Public Type OPENFILENAMEPTR  '  ofn
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As Long
  lpstrCustomFilter As Long
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As Long
  nMaxFile As Long
  lpstrFileTitle As Long
  nMaxFileTitle As Long
  lpstrInitialDir As Long
  lpstrTitle As Long
  flags As OFN_Flags
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As Long
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As Long
End Type

' File Open/Save Dialog Flags
Public Enum OFN_Flags
  OFN_READONLY = &H1
  OFN_OVERWRITEPROMPT = &H2
  OFN_HIDEREADONLY = &H4
  OFN_NOCHANGEDIR = &H8
  OFN_SHOWHELP = &H10
  OFN_ENABLEHOOK = &H20
  OFN_ENABLETEMPLATE = &H40
  OFN_ENABLETEMPLATEHANDLE = &H80
  OFN_NOVALIDATE = &H100
  OFN_ALLOWMULTISELECT = &H200
  OFN_EXTENSIONDIFFERENT = &H400
  OFN_PATHMUSTEXIST = &H800
  OFN_FILEMUSTEXIST = &H1000
  OFN_CREATEPROMPT = &H2000
  OFN_SHAREAWARE = &H4000
  OFN_NOREADONLYRETURN = &H8000&
  OFN_NOTESTFILECREATE = &H10000
  OFN_NONETWORKBUTTON = &H20000
  OFN_NOLONGNAMES = &H40000               ' force no long names for 4.x modules
  OFN_EXPLORER = &H80000                       ' new look commdlg
  OFN_NODEREFERENCELINKS = &H100000
  OFN_LONGNAMES = &H200000                 ' force long names for 3.x modules
  ' ===============================
  ' Win98/NT5 only...
  OFN_ENABLEINCLUDENOTIFY = &H400000           ' send include message to callback
  OFN_ENABLESIZING = &H800000
  ' ===============================
End Enum

' ============================================================
' notifications

' The NMHDR structure contains information about a notification message. The pointer
' to this structure is specified as the lParam member of the WM_NOTIFY message.
Public Type NMHDR
  hwndFrom As Long   ' Window handle of control sending message
  idFrom As Long        ' Identifier of control sending message
  code  As Long          ' Specifies the notification code
End Type

' Structure used for all file based OpenFileName notifications
Public Type OFNOTIFY
  hdr As NMHDR
  lpOFN As Long 'OPENFILENAME
  ' Pointer to the file name for which a network sharing violation has occurred. This member
  ' is valid only with the CDN_SHAREVIOLATION notification message. May be NULL
  pszFile As String
End Type

'' Structure used for all object based OpenFileName notifications
'' used only for CDN_INCLUDEITEM
'Public Type OFNOTIFYEX
'  hdr As NMHDR
'  lpOFN As OPENFILENAME
'  psf As IShellFolder
'  pidl As Long          ' May be NULL
'End Type

Public Const WM_NOTIFY = &H4E

' Notifications when Open or Save dialog status changes
' send via WM_NOTIFY to the OFNHookProc
Public Enum CommDlg_Notifications
  CDN_FIRST = -601&   ' (0U-601U)
  CDN_LAST = -699&    ' (0U-699U)

  ' all lParams are lp OFNOTIFY, except CDN_INCLUDEITEM
  CDN_INITDONE = (CDN_FIRST - &H0)
  CDN_SELCHANGE = (CDN_FIRST - &H1)
  CDN_FOLDERCHANGE = (CDN_FIRST - &H2)
  CDN_SHAREVIOLATION = (CDN_FIRST - &H3)
  CDN_HELP = (CDN_FIRST - &H4)
  CDN_FILEOK = (CDN_FIRST - &H5)
  CDN_TYPECHANGE = (CDN_FIRST - &H6)
  
  ' lp OFNOTIFYEX, OFN_ENABLEINCLUDENOTIFY flag is specified,
  ' sent for each item enumerated in the currently navigated folder,
  ' rtn 0 to exclude item, non-0 to include item
  CDN_INCLUDEITEM = (CDN_FIRST - &H7)

End Enum   ' CommDlg_Notifications

' ============================================================
' dialog/common dialog messages

Public Const WM_USER = &H400

Public Enum Dialog_Messages
  DM_GETDEFID = (WM_USER + 0)
  DM_SETDEFID = (WM_USER + 1)
  DM_REPOSITION = (WM_USER + 2)
  ' Returned in HIWORD() of DM_GETDEFID result if msg is supported
  DC_HASDEFID = &H534B

  WM_NEXTDLGCTL = &H28
  WM_GETDLGCODE = &H87
  WM_INITDIALOG = &H110   ' return TRUE if Windows should set the focus.

  WM_ENTERIDLE = &H121
  WM_CTLCOLORMSGBOX = &H132
  WM_CTLCOLORDLG = &H136
End Enum   ' Dialog_Messages
  
' Messages to query information from the Open or Save dialogs
Public Enum CommDlg_Messages
  CDM_FIRST = (WM_USER + 100)
  CDM_LAST = (WM_USER + 200)

' lParam = pointer to text buffer that gets filled in
' wParam = max number of characters of the text buffer (including NULL)
' return = < 0 if error; number of characters needed (including NULL)
  CDM_GETSPEC = (CDM_FIRST + &H0)

' lParam = pointer to text buffer that gets filled in
' wParam = max number of characters of the text buffer (including NULL)
' return = < 0 if error; number of characters needed (including NULL)
  CDM_GETFILEPATH = (CDM_FIRST + &H1)

' lParam = pointer to text buffer that gets filled in
' wParam = max number of characters of the text buffer (including NULL)
' return = < 0 if error; number of characters needed (including NULL)
  CDM_GETFOLDERPATH = (CDM_FIRST + &H2)

' lParam = pointer to ITEMIDLIST buffer that gets filled in
' wParam = size of the ITEMIDLIST buffer
' return = < 0 if error; length of buffer needed
  CDM_GETFOLDERIDLIST = (CDM_FIRST + &H3)

' lParam = pointer to a string
' wParam = ID of control to change
' return = not used
  CDM_SETCONTROLTEXT = (CDM_FIRST + &H4)

' lParam = not used
' wParam = ID of control to change
' return = not used
  CDM_HIDECONTROL = (CDM_FIRST + &H5)

' lParam = pointer to default extension (no dot)
' wParam = not used
' return = not used
  CDM_SETDEFEXT = (CDM_FIRST + &H6)

End Enum   ' CommDlg_Messages
'
'  CDN_FILEOK The user clicked the OK button; the dialog box is about to close.
'  CDN_FOLDERCHANGE The user opened a new folder or directory.
'  CDN_HELP The user clicked the Help button.
'  CDN_INCLUDEITEM Determines whether an item should be displayed. When the user opens a new folder or directory, the system sends this notification for each item in the folder or directory. The system sends this notification only if the OFN_ENABLEINCLUDENOTIFY flag was set.
'  CDN_INITDONE The system has finished initializing the dialog box, and the dialog box has finished processing the WM_INITDIALOG message. Also, the system has finished arranging controls in the common dialog box to make room for the controls of the child dialog box (if any).
'  CDN_SELCHANGE The user selected a new file or folder from the file list.
'  CDN_SHAREVIOLATION The common dialog box encountered a sharing violation on the file about to be returned.
'  CDN_TYPECHANGE The user selected a new file type from the list of file types.
'
'  CDM_GETFILEPATH Retrieves the path and file name of the selected file.
'  CDM_GETFOLDERIDLIST Retrieves the item identifier list corresponding to the current folder that the dialog box has open. For more information about item identifier lists, see Item Identifiers and Identifier Lists.
'  CDM_GETFOLDERPATH Retrieves the path of the current folder or directory for the dialog box.
'  CDM_GETSPEC Retrieves the file name (not including the path) of the file currently selected in the dialog box.
'  CDM_HIDECONTROL Hides the specified control.
'  CDM_SETCONTROLTEXT Sets the text in the specified control.
'  CDM_SETDEFEXT Sets the default file name extension for the dialog box.
'
'  CommDlg_OpenSave_GetSpecA(_hdlg, _psz, _cbmax) \
'        (int)SNDMSG(_hdlg, CDM_GETSPEC, (WPARAM)_cbmax, (LPARAM)(LPSTR)_psz)
'
'  CommDlg_OpenSave_GetFilePathA(_hdlg, _psz, _cbmax) \
'        (int)SNDMSG(_hdlg, CDM_GETFILEPATH, (WPARAM)_cbmax, (LPARAM)(LPSTR)_psz)
'
'  CommDlg_OpenSave_GetFolderPathA(_hdlg, _psz, _cbmax) \
'        (int)SNDMSG(_hdlg, CDM_GETFOLDERPATH, (WPARAM)_cbmax, (LPARAM)(LPSTR)_psz)
'
'  CommDlg_OpenSave_GetFolderIDList(_hdlg, _pidl, _cbmax) \
'        (int)SNDMSG(_hdlg, CDM_GETFOLDERIDLIST, (WPARAM)_cbmax, (LPARAM)(LPVOID)_pidl)
'
'  CommDlg_OpenSave_SetControlText(_hdlg, _id, _text) \
'        (void)SNDMSG(_hdlg, CDM_SETCONTROLTEXT, (WPARAM)_id, (LPARAM)(LPSTR)_text)
'
'  CommDlg_OpenSave_HideControl(_hdlg, _id) \
'        (void)SNDMSG(_hdlg, CDM_HIDECONTROL, (WPARAM)_id, 0)
'
'  CommDlg_OpenSave_SetDefExt(_hdlg, _pszext) \
'        (void)SNDMSG(_hdlg, CDM_SETDEFEXT, 0, (LPARAM)(LPSTR)_pszext)
'
' ============================================================
'
' Module level variable containing the folder selected in
' the common dialog. Filled in OFNHookProc, and passed
' to the calling proc in the BrowseForFolder proc below.
Private m_sBrowseFolder As String
'

' Fills the passed buffer with the folder selected on the Open common dialog.
' Returns True if a folder was selected, or False otherwise.

Public Function BrowseForFolder(hWnd As Long, _
                                                     sInitDir As String, _
                                                     sBuffer As String) As Boolean
  Dim ofn As OPENFILENAME
  
  ' Initialize the OPENFILENAME struct, setting the callback function.
  With ofn
    .lStructSize = Len(ofn)
    .hwndOwner = hWnd
    .lpstrFile = String$(MAX_PATH, 0)
    .nMaxFile = MAX_PATH
    .lpstrInitialDir = sInitDir
    .lpstrTitle = "Browse for folder" & vbNullChar
    .flags = OFN_ENABLEHOOK Or OFN_EXPLORER
    .lpfnHook = FARPROC(AddressOf OFNHookProc)
  End With
  
  ' Call the Open dialog (it will always return False).
  Call GetOpenFileName(ofn)
  
  ' If our module level variable was set below on
  ' an Open button click, return it, and True.
  If Len(m_sBrowseFolder) Then
    sBuffer = m_sBrowseFolder
    BrowseForFolder = True
  End If

End Function

' A dummy procedure that receives and returns the result
' of the AddressOf operator

Public Function FARPROC(pfn As Long) As Long
  FARPROC = pfn
End Function

Public Function OFNHookProc(ByVal hdlgChild As Long, _
                                                  ByVal uiMsg As Long, _
                                                  ByVal wParam As Long, _
                                                  ByVal lParam As Long) As Long
  Select Case uiMsg
    
    Case WM_NOTIFY
      Dim ofnot As OFNOTIFY
      Dim sNewFolder As String * MAX_PATH
      Dim nChars As Integer

      ' fill the OFNOTIFY struct
      MoveMemory ofnot, ByVal lParam, Len(ofnot)

'Debug.Print GetComDlgNotifyCodeStr(ofnot.hdr.code)

      Select Case ofnot.hdr.code
        
        ' =========================================
        ' Sent to the dialog when a file is selected and the Open
        ' button has been clicked
        
        Case CDN_FILEOK
          
          ' Get the currently selected folder and set the module level variable.
          nChars = SendMessage(GetParent(hdlgChild), CDM_GETFOLDERPATH, MAX_PATH, ByVal sNewFolder)
          If (nChars > 0) Then
            m_sBrowseFolder = Left$(sNewFolder, nChars)
          End If
        
        ' =========================================
        ' Sent to the dialog when a folder has been opened.
        ' This notification is called once before the dialog opens,
        ' anytime a new folder is navigated to in the dialog, *or*
        ' when the Open button is clicked and no file or folder
        ' is currently selected in the dialog.
        
        Case CDN_FOLDERCHANGE
          Static sPrevFolder As String * MAX_PATH
          Dim pt As POINTAPI
          Dim hWnd As Long
          Dim sText As String * MAX_PATH
          
          ' Get the currently selected folder.
          nChars = SendMessage(GetParent(hdlgChild), CDM_GETFOLDERPATH, MAX_PATH, ByVal sNewFolder)
          If (nChars > 0) Then
            sNewFolder = Left$(sNewFolder, nChars)
'Debug.Print Left$(sNewFolder, nChars)
            
            ' Are the previously and currently selected folders the same?
            If StrComp(sPrevFolder, sNewFolder, vbTextCompare) <> 0 Then
              
              ' No, a folder has been navigated to in the dialog.
              ' Cache the currently selected folder as the previously selected folder
              sPrevFolder = sNewFolder
            
            Else
              
              ' The previously and currently selected folders the same.
              ' See if the "Open" buton was clicked...
            
              ' Get the cursor position
              If GetCursorPos(pt) Then
                
                ' Get the handle of the window under the cursor
                hWnd = WindowFromPoint(pt.x, pt.y)
                If hWnd Then
                  
                  ' Get the widow's text
                  If GetWindowText(hWnd, sText, MAX_PATH) Then
                    
                    ' Does the window's text match the Open button's text?
                    If Left$(sText, 5) = "&Open" Then
                      ' Yes, set the module level variable
                      m_sBrowseFolder = sNewFolder
                      ' close the dialog
                      Call SendMessage(GetParent(hdlgChild), WM_CLOSE, 0, 0)
                    Else
                      ' The open button was not clicked, clear the module
                      ' level variable in case the Cancel button was clicked
                      m_sBrowseFolder = "'"
                    End If   ' Left$
                  
                  End If   ' GetWindowText
                End If   ' hWnd
              End If   ' GetCursorPos
            End If   ' StrComp
          End If   ' (nChars > 0)
            
      End Select   ' ofnot.hdr.code

'    Case Else
'Debug.Print GetWinMsgStr(uiMsg) & ", &H" & Hex(wParam) & ", &H" & Hex(lParam)
        
  End Select   ' uiMsg

End Function
